com.smartgwt.client.widgets.cube

## Class Facet

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.cube.Facet

-     public class Facet
      extends RefDataClass

  Facet definition object made use of by the `CubeGrid` and `FacetChart` classes.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.DataClass

      `factoryCreated, factoryProperties`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Facet()`
    `Facet(JavaScriptObject jsObj)`
    `Facet(java.lang.String id)`
    `Facet(java.lang.String id, java.lang.String title)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Alignment` | `getAlign()` Default alignment for facet label title, and cells for this facet.
    `java.lang.String` | `getBorderAfter()` CSS line style to apply as a border after this facet, eg "1px dashed blue"
    `java.lang.String` | `getBorderBefore()` CSS line style to apply as a border before this facet, eg "1px dashed blue"
    `java.lang.Boolean` | `getCanCollapse()` For tree facets, whether expand/collapse controls should be shown.
    `java.lang.Boolean` | `getCanMinimize()` If facet minimizing is enabled, whether this facet should show controls to minimize the next facet.
    `Alignment` | `getCellAlign()` Default alignment of cells (in the body) for this facet.
    `java.lang.Boolean` | `getCollapsed()` For tree facets, default collapse state for parent nodes.
    `java.lang.Integer` | `getHeight()` Integer number of pixels.
    `java.lang.Object` | `getId()` id of this facet.
    `java.lang.Integer` | `getIdAsInt()` id of this facet.
    `java.lang.String` | `getIdAsString()` id of this facet.
    `java.lang.Boolean` | `getInlinedValues()` When applied to a Chart, does the chart's data contain multiple values per record for this facet.
    `java.lang.Boolean` | `getIsTree()` Marks this facet as a hierarchical facet.
    `java.lang.Integer` | `getLabelHeight()` Integer number of pixels.
    `static Facet` | `getOrCreateRef(JavaScriptObject jsObj)`
    `java.lang.String` | `getProportionalTitle()` For `FacetCharts` only, this property specifies the value axis label when a FacetChart is in `proportional rendering mode` and has this facet as its `legend facet`.
    `java.lang.String` | `getRollupValue()` facetValueId of the rollup facetValue for this facet.
    `SelectionBoundary` | `getSelectionBoundary()` Selection boundary determining what facets / facetValues can be selected together by drag selection / shift+click selection.
    `java.lang.Boolean` | `getShowParentsLast()` Indicates internal hierarchy should be displayed in reverse of normal tree order (so that parents follow children).
    `java.lang.String` | `getSummaryTitle()` Title for facet summary.
    `java.lang.String` | `getSummaryValue()` Value for facet summary.
    `java.lang.Boolean` | `getSynchColumnLayout()` If true, treat all values in this facet as a facetValueGroup - causes synched header reorder and resize.
    `java.lang.String` | `getTitle()` User-visible title of this facet.
    `Alignment` | `getTitleAlign()` Alignment of facet label title.
    `FacetValue[]` | `getValues()` Array of facetValue definitions.
    `int` | `getWidth()` Integer number of pixels.
    `void` | `setAlign(Alignment align)` Default alignment for facet label title, and cells for this facet.
    `void` | `setBorderAfter(java.lang.String borderAfter)` CSS line style to apply as a border after this facet, eg "1px dashed blue"
    `void` | `setBorderBefore(java.lang.String borderBefore)` CSS line style to apply as a border before this facet, eg "1px dashed blue"
    `void` | `setCanCollapse(java.lang.Boolean canCollapse)` For tree facets, whether expand/collapse controls should be shown.
    `void` | `setCanMinimize(java.lang.Boolean canMinimize)` If facet minimizing is enabled, whether this facet should show controls to minimize the next facet.
    `void` | `setCellAlign(Alignment cellAlign)` Default alignment of cells (in the body) for this facet.
    `void` | `setCollapsed(java.lang.Boolean collapsed)` For tree facets, default collapse state for parent nodes.
    `void` | `setHeight(java.lang.Integer height)` Integer number of pixels.
    `void` | `setId(java.lang.Integer id)` id of this facet.
    `void` | `setId(java.lang.String id)` id of this facet.
    `void` | `setInlinedValues(java.lang.Boolean inlinedValues)` When applied to a Chart, does the chart's data contain multiple values per record for this facet.
    `void` | `setIsTree(java.lang.Boolean isTree)` Marks this facet as a hierarchical facet.
    `void` | `setLabelHeight(java.lang.Integer labelHeight)` Integer number of pixels.
    `void` | `setProportionalTitle(java.lang.String proportionalTitle)` For `FacetCharts` only, this property specifies the value axis label when a FacetChart is in `proportional rendering mode` and has this facet as its `legend facet`.
    `void` | `setRollupValue(java.lang.String rollupValue)` facetValueId of the rollup facetValue for this facet.
    `void` | `setSelectionBoundary(SelectionBoundary selectionBoundary)` Selection boundary determining what facets / facetValues can be selected together by drag selection / shift+click selection.
    `void` | `setShowParentsLast(java.lang.Boolean showParentsLast)` Indicates internal hierarchy should be displayed in reverse of normal tree order (so that parents follow children).
    `void` | `setSummaryTitle(java.lang.String summaryTitle)` Title for facet summary.
    `void` | `setSummaryValue(java.lang.String summaryValue)` Value for facet summary.
    `void` | `setSynchColumnLayout(java.lang.Boolean synchColumnLayout)` If true, treat all values in this facet as a facetValueGroup - causes synched header reorder and resize.
    `void` | `setTitle(java.lang.String title)` User-visible title of this facet.
    `void` | `setTitleAlign(Alignment titleAlign)` Alignment of facet label title.
    `void` | `setValues(FacetValue... values)` Array of facetValue definitions.
    `void` | `setWidth(int width)` Integer number of pixels.

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `applyFactoryProperties, doAddHandler, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsDoubleArray, getAttributeAsFloat, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, getJsObj, hashCode, isCreated, setJavaScriptObject, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Facet

          public Facet()

    - #### Facet

          public Facet(JavaScriptObject jsObj)

    - #### Facet

          public Facet(java.lang.String id)

    - #### Facet

          public Facet(java.lang.String id,
               java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static Facet getOrCreateRef(JavaScriptObject jsObj)

    - #### setAlign

          public void setAlign(Alignment align)

      Default alignment for facet label title, and cells for this facet. Can be overridden at the facetValue level, or by setting titleAlign or cellAlign on the facet.

      Note: This property is specific to `CubeGrids` (see, for example, `facetValueAlign`).

      Parameters:
        `align` - Default value is null
      See Also:
        `setTitleAlign(com.smartgwt.client.types.Alignment)`, `setCellAlign(com.smartgwt.client.types.Alignment)`

    - #### getAlign

          public Alignment getAlign()

      Default alignment for facet label title, and cells for this facet. Can be overridden at the facetValue level, or by setting titleAlign or cellAlign on the facet.

      Note: This property is specific to `CubeGrids` (see, for example, `facetValueAlign`).

      Returns:
        Alignment
      See Also:
        `getTitleAlign()`, `getCellAlign()`

    - #### setBorderAfter

          public void setBorderAfter(java.lang.String borderAfter)

      CSS line style to apply as a border after this facet, eg "1px dashed blue"

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `borderAfter` - Default value is null

    - #### getBorderAfter

          public java.lang.String getBorderAfter()

      CSS line style to apply as a border after this facet, eg "1px dashed blue"

      Note: This property is specific to `CubeGrids`.

      Returns:
        String

    - #### setBorderBefore

          public void setBorderBefore(java.lang.String borderBefore)

      CSS line style to apply as a border before this facet, eg "1px dashed blue"

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `borderBefore` - Default value is null

    - #### getBorderBefore

          public java.lang.String getBorderBefore()

      CSS line style to apply as a border before this facet, eg "1px dashed blue"

      Note: This property is specific to `CubeGrids`.

      Returns:
        String

    - #### setCanCollapse

          public void setCanCollapse(java.lang.Boolean canCollapse)

      For tree facets, whether expand/collapse controls should be shown.

      Note: This property is specific to `CubeGrids` (see, for example, `canCollapseFacets`).

      Parameters:
        `canCollapse` - Default value is facet.isTree

    - #### getCanCollapse

          public java.lang.Boolean getCanCollapse()

      For tree facets, whether expand/collapse controls should be shown.

      Note: This property is specific to `CubeGrids` (see, for example, `canCollapseFacets`).

      Returns:
        Boolean

    - #### setCanMinimize

          public void setCanMinimize(java.lang.Boolean canMinimize)

      If facet minimizing is enabled, whether this facet should show controls to minimize the next facet. Generally a tree facet should not also allow minimizing the next facet - the interaction of the two types of collapsing can be confusing.

      Note: This property is specific to `CubeGrids`. See `canMinimizeFacets`.

      Parameters:
        `canMinimize` - Default value is cubeGrid.canMinimizeFacets

    - #### getCanMinimize

          public java.lang.Boolean getCanMinimize()

      If facet minimizing is enabled, whether this facet should show controls to minimize the next facet. Generally a tree facet should not also allow minimizing the next facet - the interaction of the two types of collapsing can be confusing.

      Note: This property is specific to `CubeGrids`. See `canMinimizeFacets`.

      Returns:
        Boolean

    - #### setCellAlign

          public void setCellAlign(Alignment cellAlign)

      Default alignment of cells (in the body) for this facet.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `cellAlign` - Default value is cubeGrid.cellAlign
      See Also:
        `CubeGrid.setCellAlign(com.smartgwt.client.types.Alignment)`

    - #### getCellAlign

          public Alignment getCellAlign()

      Default alignment of cells (in the body) for this facet.

      Note: This property is specific to `CubeGrids`.

      Returns:
        Alignment
      See Also:
        `CubeGrid.getCellAlign()`

    - #### setCollapsed

          public void setCollapsed(java.lang.Boolean collapsed)

      For tree facets, default collapse state for parent nodes.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `collapsed` - Default value is false

    - #### getCollapsed

          public java.lang.Boolean getCollapsed()

      For tree facets, default collapse state for parent nodes.

      Note: This property is specific to `CubeGrids`.

      Returns:
        Boolean

    - #### setHeight

          public void setHeight(java.lang.Integer height)

      Integer number of pixels. For column facets, specifies the height of header. Has no effect on row facets.

      If this property conflicts with a `labelHeight`, the greater of the two properties will be used for determining the height of the affected row.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `height` - Default value is null

    - #### getHeight

          public java.lang.Integer getHeight()

      Integer number of pixels. For column facets, specifies the height of header. Has no effect on row facets.

      If this property conflicts with a `labelHeight`, the greater of the two properties will be used for determining the height of the affected row.

      Note: This property is specific to `CubeGrids`.

      Returns:
        Integer

    - #### setInlinedValues

          public void setInlinedValues(java.lang.Boolean inlinedValues)

      When applied to a Chart, does the chart's data contain multiple values per record for this facet. See data for a full overview of `inlinedValues` behavior.
      Parameters:
        `inlinedValues` - Default value is null

    - #### getInlinedValues

          public java.lang.Boolean getInlinedValues()

      When applied to a Chart, does the chart's data contain multiple values per record for this facet. See data for a full overview of `inlinedValues` behavior.
      Returns:
        Boolean

    - #### setIsTree

          public void setIsTree(java.lang.Boolean isTree)

      Marks this facet as a hierarchical facet.

      If set, `facet.value` will be linked as for a `modelType:"parent"` Tree, using `facetValue.id` and `facetValue.parentId`. Expand/collapse controls will be shown allowing navigation of the facet's values.

      The CubeGrid's `load on demand` system automatically avoids fetching data for facetValues that are not currently visible due to the expand/collapse state of a tree facet.

      Initial open/close state can be controlled via `facet.collapsed` and `collapsed`.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `isTree` - Default value is false

    - #### getIsTree

          public java.lang.Boolean getIsTree()

      Marks this facet as a hierarchical facet.

      If set, `facet.value` will be linked as for a `modelType:"parent"` Tree, using `facetValue.id` and `facetValue.parentId`. Expand/collapse controls will be shown allowing navigation of the facet's values.

      The CubeGrid's `load on demand` system automatically avoids fetching data for facetValues that are not currently visible due to the expand/collapse state of a tree facet.

      Initial open/close state can be controlled via `facet.collapsed` and `collapsed`.

      Note: This property is specific to `CubeGrids`.

      Returns:
        Boolean

    - #### setLabelHeight

          public void setLabelHeight(java.lang.Integer labelHeight)

      Integer number of pixels. For column facets other than the innermost, specifies the height of the header. For row facets, specifies the height of the row containing that row facet's label (which is the same row containing the innermost column facet if one or more column facets are present).

      If this property conflicts with a `height`, the greater of the two properties will be used for determining the height of the affected row.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `labelHeight` - Default value is null

    - #### getLabelHeight

          public java.lang.Integer getLabelHeight()

      Integer number of pixels. For column facets other than the innermost, specifies the height of the header. For row facets, specifies the height of the row containing that row facet's label (which is the same row containing the innermost column facet if one or more column facets are present).

      If this property conflicts with a `height`, the greater of the two properties will be used for determining the height of the affected row.

      Note: This property is specific to `CubeGrids`.

      Returns:
        Integer

    - #### setProportionalTitle

          public void setProportionalTitle(java.lang.String proportionalTitle)

      For `FacetCharts` only, this property specifies the value axis label when a FacetChart is in `proportional rendering mode` and has this facet as its `legend facet`. If the `proportionalTitle` is not specified then `proportionalAxisLabel` is used as the default title.
      Parameters:
        `proportionalTitle` - Default value is null

    - #### getProportionalTitle

          public java.lang.String getProportionalTitle()

      For `FacetCharts` only, this property specifies the value axis label when a FacetChart is in `proportional rendering mode` and has this facet as its `legend facet`. If the `proportionalTitle` is not specified then `proportionalAxisLabel` is used as the default title.
      Returns:
        String

    - #### setRollupValue

          public void setRollupValue(java.lang.String rollupValue)

      facetValueId of the rollup facetValue for this facet.

      Note: This property is specific to `CubeGrids`. See `rollupValue`.

      Parameters:
        `rollupValue` - Default value is cubeGrid.rollupValue

    - #### getRollupValue

          public java.lang.String getRollupValue()

      facetValueId of the rollup facetValue for this facet.

      Note: This property is specific to `CubeGrids`. See `rollupValue`.

      Returns:
        String

    - #### setSelectionBoundary

          public void setSelectionBoundary(SelectionBoundary selectionBoundary)

      Selection boundary determining what facets / facetValues can be selected together by drag selection / shift+click selection.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `selectionBoundary` - Default value is null

    - #### getSelectionBoundary

          public SelectionBoundary getSelectionBoundary()

      Selection boundary determining what facets / facetValues can be selected together by drag selection / shift+click selection.

      Note: This property is specific to `CubeGrids`.

      Returns:
        SelectionBoundary

    - #### setShowParentsLast

          public void setShowParentsLast(java.lang.Boolean showParentsLast)

      Indicates internal hierarchy should be displayed in reverse of normal tree order (so that parents follow children).

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `showParentsLast` - Default value is false

    - #### getShowParentsLast

          public java.lang.Boolean getShowParentsLast()

      Indicates internal hierarchy should be displayed in reverse of normal tree order (so that parents follow children).

      Note: This property is specific to `CubeGrids`.

      Returns:
        Boolean

    - #### setSummaryTitle

          public void setSummaryTitle(java.lang.String summaryTitle)

      Title for facet summary.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `summaryTitle` - Default value is cubeGrid.summaryTitle

    - #### getSummaryTitle

          public java.lang.String getSummaryTitle()

      Title for facet summary.

      Note: This property is specific to `CubeGrids`.

      Returns:
        String

    - #### setSummaryValue

          public void setSummaryValue(java.lang.String summaryValue)

      Value for facet summary.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `summaryValue` - Default value is cubeGrid.summaryValue

    - #### getSummaryValue

          public java.lang.String getSummaryValue()

      Value for facet summary.

      Note: This property is specific to `CubeGrids`.

      Returns:
        String

    - #### setSynchColumnLayout

          public void setSynchColumnLayout(java.lang.Boolean synchColumnLayout)

      If true, treat all values in this facet as a facetValueGroup - causes synched header reorder and resize.

      Note: This property is specific to `CubeGrids` and is only supported when all of a facet's values are used.

      Parameters:
        `synchColumnLayout` - Default value is true

    - #### getSynchColumnLayout

          public java.lang.Boolean getSynchColumnLayout()

      If true, treat all values in this facet as a facetValueGroup - causes synched header reorder and resize.

      Note: This property is specific to `CubeGrids` and is only supported when all of a facet's values are used.

      Returns:
        Boolean

    - #### setTitle

          public void setTitle(java.lang.String title)

      User-visible title of this facet. Shown on the facet label in the CubeGrid.
      Parameters:
        `title` - Default value is null

    - #### getTitle

          public java.lang.String getTitle()

      User-visible title of this facet. Shown on the facet label in the CubeGrid.
      Returns:
        String

    - #### setTitleAlign

          public void setTitleAlign(Alignment titleAlign)

      Alignment of facet label title.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `titleAlign` - Default value is cubeGrid.facetTitleAlign
      See Also:
        `CubeGrid.setFacetTitleAlign(com.smartgwt.client.types.Alignment)`

    - #### getTitleAlign

          public Alignment getTitleAlign()

      Alignment of facet label title.

      Note: This property is specific to `CubeGrids`.

      Returns:
        Alignment
      See Also:
        `CubeGrid.getFacetTitleAlign()`

    - #### setValues

          public void setValues(FacetValue... values)

      Array of facetValue definitions.
      Parameters:
        `values` - Default value is null
      See Also:
        `FacetValue`

    - #### getValues

          public FacetValue[] getValues()

      Array of facetValue definitions.
      Returns:
        FacetValue...
      See Also:
        `FacetValue`

    - #### setWidth

          public void setWidth(int width)

      Integer number of pixels. For row facets, width of headers.

      Note: This property is specific to `CubeGrids`.

      Parameters:
        `width` - Default value is cubeGrid.defaultFacetWidth
      See Also:
        `CubeGrid.setDefaultFacetWidth(int)`

    - #### getWidth

          public int getWidth()

      Integer number of pixels. For row facets, width of headers.

      Note: This property is specific to `CubeGrids`.

      Returns:
        int
      See Also:
        `CubeGrid.getDefaultFacetWidth()`

    - #### setId

          public void setId(java.lang.Integer id)

      id of this facet. Any string or number.
      Parameters:
        `id` - id Default value is null

    - #### setId

          public void setId(java.lang.String id)

      id of this facet. Any string or number.
      Parameters:
        `id` - id Default value is null

    - #### getId

          public java.lang.Object getId()

      id of this facet. Any string or number.
      Parameters:
        `id` - id Default value is null

    - #### getIdAsString

          public java.lang.String getIdAsString()

      id of this facet. Any string or number.
      Parameters:
        `id` - id Default value is null

    - #### getIdAsInt

          public java.lang.Integer getIdAsInt()

      id of this facet. Any string or number.
      Parameters:
        `id` - id Default value is null